首页 > 代码库 > 转化一下就是01背包 CodeForces 433A - Kitahara Haruki's Gift

转化一下就是01背包 CodeForces 433A - Kitahara Haruki's Gift

Kitahara Haruki has bought n apples for Touma Kazusa and Ogiso Setsuna. Now he wants to divide all the apples between the friends.

Each apple weights 100 grams or 200 grams. Of course Kitahara Haruki doesn‘t want to offend any of his friend. Therefore the total weight of the apples given to Touma Kazusa must be equal to the total weight of the apples given to Ogiso Setsuna.

But unfortunately Kitahara Haruki doesn‘t have a knife right now, so he cannot split any apple into some parts. Please, tell him: is it possible to divide all the apples in a fair way between his friends?

Input

The first line contains an integer n (1?≤?n?≤?100) — the number of apples. The second line contains n integers w1,?w2,?...,?wn (wi?=?100 or wi?=?200), where wi is the weight of the i-th apple.

Output

In a single line print "YES" (without the quotes) if it is possible to divide all the apples between his friends. Otherwise print "NO" (without the quotes).

Sample test(s)
input
3
100 200 100
output
YES
input
4
100 100 100 200
output
NO
Note

In the first test sample Kitahara Haruki can give the first and the last apple to Ogiso Setsuna and the middle apple to Touma Kazusa.

题目就是说一个人买了一大堆的apple,然后给出每个苹果的质量,要求将这些苹果分成等质量的两堆,不就是动态规划吗???!!!
讲一下思路:先将质量全部加起来为sum,如果sum余2不为零直接NO,然后sum/=2;接下来就是01背包了,只要dp[sum/2]==sum/2;就行了
嗯,贴下代码:
#include<stdio.h>
#include<string.h>
#include<math.h>
#include<iostream>
using namespace std;

int main()
{
    int i,j,k;
    int t,n,m;
    __int64 sum;
    int liu[106],dp[250000];
    while(scanf("%d",&n)!=EOF)
    {
        sum=0;
        memset(liu,0,sizeof(liu));
        memset(dp,0,sizeof(dp));
        for(i=1;i<=n;i++)
        {
            scanf("%d",&liu[i]);
            sum+=liu[i];
        }
        if(sum%2!=0)
        {
            printf("NO\n");
            continue;
        }
        sum/=2;
        //printf("%d\n",sum);
        for(i=1;i<=n;i++)
        {
            for(j=sum;j>=liu[i];j--)
                dp[j]=max(dp[j],dp[j-liu[i]]+liu[i]);
        }
        if(dp[sum]==sum)
            printf("YES\n");
        else
            printf("NO\n");
    }
    return 0;
}

发现bug就讲吧,谢谢;